<!-- DIM RPC IN Node -->
<script type="text/javascript">
  (async function() {
    if (!window.dimPromise) {
      const prom = {};
      prom.promise = new Promise((resolve) => (prom.resolve = resolve));
      window.dimPromise = prom;
      /* will be resolved by DimConf script */
    }

    const dim = await dimPromise.promise;
    dim.utils.genNodeTemplate("dim-rpc in", {
      nodeName: {
      property: "name",
      label: RED._('node-red-dim/disRpc:disRpc.label.node-name')
    },
    nodeConf: {
      property: "cnf",
      label: RED._('node-red-dim/disRpc:disRpc.label.node-conf')
    },
    serviceName: {
      property: "serviceName",
      label: RED._('node-red-dim/disRpc:disRpc.label.service-name')
    },
    serviceDefinitions: [
      {
        property: "serviceDefIn",
        label: RED._('node-red-dim/disRpc:disRpc.label.service-definition-in')
      },
      {
        property: "serviceDefOut",
        label: RED._('node-red-dim/disRpc:disRpc.label.service-definition-out')
      }
    ]
    });

    RED.nodes.registerType("dim-rpc in", {
      category: 'network',
      color: '#F3B567',
      defaults: {
        name: { value: "" },
        cnf: { type: "dim-conf", required: true },
        serviceName: { value: "", required: true,
          validate: RED.validators.regex(dis.regExp.srvName)
        },
        serviceDef: { value: "" },
        serviceDefIn: { value: "", required: true,
          validate: function(d) {
            if (!d) { return false; }

            const res = d.match(dis.regExp.srvDefDescr);
            if (res) {
              d = d.slice(0, res.index); /* extract service definition */
              $('#node-input-serviceDefIn').val(d);
            }
            this.serviceDefIn = d;
            return dis.regExp.srvDefFormat.test(d);
          }
        },
        serviceDefOut: { value: "", required: true,
          validate: function(d) {
            if (!d) { return false; }

            const res = d.match(dis.regExp.srvDefDescr);
            if (res) {
              d = d.slice(0, res.index); /* extract service definition */
              $('#node-input-serviceDefOut').val(d);
            }
            this.serviceDefOut = d;
            return dis.regExp.srvDefFormat.test(d);
          }
        }
      },
      icon: 'bridge.svg',
      inputs: 0,
      outputs: 1,
      label: function() {
        const def = (this.serviceName && this.serviceDefIn &&
          this.serviceDefOut) ?
          " [ " + this.serviceDefIn + ',' + this.serviceDefOut + " ]" : "";
        return this.name || this.serviceName + def || "DIM RPC In";
      },
      oneditsave: function() {
        this.serviceDef = this.serviceDefIn + ',' + this.serviceDefOut;
      }
    });
  }());
</script>

<script type="text/html" data-template-name="dim-rpc in"></script>


<!-- DIM RPC RESPONSE Node -->
<script type="text/javascript">
  (async function() {
    if (!window.dimPromise) {
      const prom = {};
      prom.promise = new Promise((resolve) => (prom.resolve = resolve));
      window.dimPromise = prom;
      /* will be resolved by DimConf script */
    }

    const dim = await dimPromise.promise;
    dim.utils.genNodeTemplate("dim-rpc-response", {
      nodeName: { property: "name", label: "Name" }
    });

    RED.nodes.registerType("dim-rpc-response", {
      category: 'network',
      color: '#F3B567',
      defaults: {
        name: { value: "" }
      },
      icon: 'bridge.svg',
      inputs: 1,
      outputs: 0,
      label: function() {
        return this.name || "DIM RPC Response";
      }
    });
  }());
</script>

<script type="text/html" data-template-name="dim-rpc-response">
  <div class="form-tips"><span data-i18n="[html]disRpc.tip.rpc-response"></span></div>
</script>
